/*
 * MainView.java
 */

package p4utest;

import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;

/**
 * The application's main frame.
 */
public class MainView extends FrameView {

    public MainView(SingleFrameApplication app) {
        super(app);
               
        initComponents();
        
        String[][] search_list = {
                                {"[嫁自慢]にっしー画像集.zip","100","100","100"},
                                {"[2006]体育祭.zip","100","100","100"},
                                {"[2006]文化祭.zip","100","100","100"},
                                {"[2007]体育祭.zip","100","100","100"},
                                {"[2006][第3学年][1学期][中間]日本史(鮮鋭化＋ノイズ除去).zip","100","100","100"},
                                {"[2006][第3学年][1学期][中間]化学(鮮鋭化＋ノイズ除去).zip","100","100","100"},
                                {"[2006][第3学年][1学期][中間]数学(鮮鋭化＋ノイズ除去).zip","100","100","100"},
                                {"[2006][第3学年][1学期][中間]倫理(鮮鋭化＋ノイズ除去).zip","100","100","100"},
                                {"[2006][第3学年][1学期][中間]物理(鮮鋭化＋ノイズ除去).zip","100","100","100"}
        };
        
        String[][] download_list = {
                                {"[嫁自慢]にっしー画像集.zip","100","10","10"}
        };
        
        String[][] upload_list = {
                                {"[2007]体育祭.zip","100","100","100"}                                
        }; 
        
        
        tableAdd("search", search_list);
        tableAdd("download", download_list);
        tableAdd("upload", upload_list);
              
        
        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = MainApp.getApplication().getMainFrame();
            aboutBox = new AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        MainApp.getApplication().show(aboutBox);
    }
    
    @Action
    public void showOptionBox() {
        if (optionBox == null) {
            JFrame mainFrame = MainApp.getApplication().getMainFrame();
            optionBox = new OptionBox(mainFrame);
            optionBox.setLocationRelativeTo(mainFrame);
        }
        MainApp.getApplication().show(optionBox);
    }
    
    /**
     * ログを出力
     */
    public void putLog(final String msg) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                statusMessageLabel.setText(msg);
                LogText.append(msg + "\n");
                LogText.setCaretPosition(LogText.getText().length());
            }
        });
    }
    

    /**
     * 各 jTable に要素を追加
     */
    private void tableAdd(final String place, final String list[][]) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                if (place.equals("search")) {
                    for (int i = 0; i < list.length; i++) {
                        SearchTableModel.addRow(new Object[]{list[i][0], list[i][1], list[i][2], list[i][3]});
                    }
                }
                if (place.equals("download")) {
                    for (int i = 0; i < list.length; i++) {
                        DownloadTableModel.addRow(new Object[]{list[i][0], list[i][1], list[i][2], list[i][3]});
                    }
                }
                if (place.equals("upload")) {
                    for (int i = 0; i < list.length; i++) {
                        UploadTableModel.addRow(new Object[]{list[i][0], list[i][1], list[i][2], list[i][3]});
                    }
                }
            }
        });
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mainPanel = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        SearchPanel = new javax.swing.JPanel();
        SearchEdit = new javax.swing.JTextField();
        SearchButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        SearchTable = new javax.swing.JTable();
        UploadPanel = new javax.swing.JPanel();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        DownloadPanel = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        DownloadTable = new javax.swing.JTable();
        SendPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        UploadTable = new javax.swing.JTable();
        LogPanel = new javax.swing.JPanel();
        jScrollPanel4 = new javax.swing.JScrollPane();
        LogText = new javax.swing.JTextArea();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        mainPanel.setName("mainPanel"); // NOI18N

        jSplitPane2.setDividerLocation(400);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setAlignmentX(0.5F);
        jSplitPane2.setAlignmentY(0.5F);
        jSplitPane2.setName("jSplitPane2"); // NOI18N

        jTabbedPane1.setName("jTabbedPane1"); // NOI18N

        SearchPanel.setName("SearchPanel"); // NOI18N
        SearchPanel.setLayout(new java.awt.GridBagLayout());

        SearchEdit.setMargin(new java.awt.Insets(0, 0, 0, 0));
        SearchEdit.setName("SearchEdit"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        SearchPanel.add(SearchEdit, gridBagConstraints);

        SearchButton.setMnemonic('S');
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(p4utest.MainApp.class).getContext().getResourceMap(MainView.class);
        SearchButton.setText(resourceMap.getString("SearchButton.text")); // NOI18N
        SearchButton.setAlignmentY(0.0F);
        SearchButton.setName("SearchButton"); // NOI18N
        SearchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SearchButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        SearchPanel.add(SearchButton, gridBagConstraints);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        SearchTableModel = new javax.swing.table.DefaultTableModel(
            null,
            new String [] {
                "ファイル名", "サイズ", "所有者数", "ハッシュ"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        };
        SearchTable.setModel(SearchTableModel);
        SearchTable.setBackground(resourceMap.getColor("SearchTable.background")); // NOI18N
        SearchTable.setForeground(resourceMap.getColor("SearchTable.foreground")); // NOI18N
        SearchTable.setGridColor(resourceMap.getColor("SearchTable.gridColor")); // NOI18N
        SearchTable.setName("SearchTable"); // NOI18N
        SearchTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                SearchTableMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(SearchTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        SearchPanel.add(jScrollPane1, gridBagConstraints);

        jTabbedPane1.addTab(resourceMap.getString("SearchPanel.TabConstraints.tabTitle"), SearchPanel); // NOI18N

        UploadPanel.setName("UploadPanel"); // NOI18N

        javax.swing.GroupLayout UploadPanelLayout = new javax.swing.GroupLayout(UploadPanel);
        UploadPanel.setLayout(UploadPanelLayout);
        UploadPanelLayout.setHorizontalGroup(
            UploadPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 793, Short.MAX_VALUE)
        );
        UploadPanelLayout.setVerticalGroup(
            UploadPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 369, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab(resourceMap.getString("UploadPanel.TabConstraints.tabTitle"), UploadPanel); // NOI18N

        jTabbedPane1.setMnemonicAt(0, 'A');
        jTabbedPane1.setMnemonicAt(1, 'R');

        jSplitPane2.setLeftComponent(jTabbedPane1);

        jTabbedPane2.setName("jTabbedPane2"); // NOI18N

        DownloadPanel.setName("DownloadPanel"); // NOI18N

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        DownloadTableModel = new javax.swing.table.DefaultTableModel(
            null,
            new String [] {
                "ファイル名", "サイズ", "進行","速度"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        };
        DownloadTable.setModel(DownloadTableModel);
        DownloadTable.setBackground(resourceMap.getColor("DownloadTable.background")); // NOI18N
        DownloadTable.setForeground(resourceMap.getColor("DownloadTable.foreground")); // NOI18N
        DownloadTable.setGridColor(resourceMap.getColor("DownloadTable.gridColor")); // NOI18N
        DownloadTable.setName("DownloadTable"); // NOI18N
        jScrollPane2.setViewportView(DownloadTable);

        javax.swing.GroupLayout DownloadPanelLayout = new javax.swing.GroupLayout(DownloadPanel);
        DownloadPanel.setLayout(DownloadPanelLayout);
        DownloadPanelLayout.setHorizontalGroup(
            DownloadPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 793, Short.MAX_VALUE)
        );
        DownloadPanelLayout.setVerticalGroup(
            DownloadPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
        );

        jTabbedPane2.addTab(resourceMap.getString("DownloadPanel.TabConstraints.tabTitle"), DownloadPanel); // NOI18N

        SendPanel.setName("SendPanel"); // NOI18N

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        UploadTableModel = new javax.swing.table.DefaultTableModel(
            null,
            new String [] {
                "ファイル名", "サイズ", "進行","速度"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        };
        UploadTable.setModel(UploadTableModel);
        UploadTable.setBackground(resourceMap.getColor("UploadTable.background")); // NOI18N
        UploadTable.setForeground(resourceMap.getColor("UploadTable.foreground")); // NOI18N
        UploadTable.setGridColor(resourceMap.getColor("UploadTable.gridColor")); // NOI18N
        UploadTable.setName("UploadTable"); // NOI18N
        jScrollPane3.setViewportView(UploadTable);

        javax.swing.GroupLayout SendPanelLayout = new javax.swing.GroupLayout(SendPanel);
        SendPanel.setLayout(SendPanelLayout);
        SendPanelLayout.setHorizontalGroup(
            SendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 793, Short.MAX_VALUE)
        );
        SendPanelLayout.setVerticalGroup(
            SendPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
        );

        jTabbedPane2.addTab(resourceMap.getString("SendPanel.TabConstraints.tabTitle"), SendPanel); // NOI18N

        LogPanel.setName("LogPanel"); // NOI18N

        jScrollPanel4.setName("jScrollPanel4"); // NOI18N

        LogText.setBackground(resourceMap.getColor("LogText.background")); // NOI18N
        LogText.setColumns(20);
        LogText.setForeground(resourceMap.getColor("LogText.foreground")); // NOI18N
        LogText.setRows(5);
        LogText.setName("LogText"); // NOI18N
        jScrollPanel4.setViewportView(LogText);

        javax.swing.GroupLayout LogPanelLayout = new javax.swing.GroupLayout(LogPanel);
        LogPanel.setLayout(LogPanelLayout);
        LogPanelLayout.setHorizontalGroup(
            LogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 793, Short.MAX_VALUE)
        );
        LogPanelLayout.setVerticalGroup(
            LogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
        );

        jTabbedPane2.addTab(resourceMap.getString("LogPanel.TabConstraints.tabTitle"), LogPanel); // NOI18N

        jTabbedPane2.setMnemonicAt(0, 'D');
        jTabbedPane2.setMnemonicAt(1, 'U');
        jTabbedPane2.setMnemonicAt(2, 'L');

        jSplitPane2.setRightComponent(jTabbedPane2);

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 800, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jSplitPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 550, Short.MAX_VALUE)
                .addGap(1, 1, 1))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setMnemonic('F');
        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(p4utest.MainApp.class).getContext().getActionMap(MainView.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setText(resourceMap.getString("exitMenuItem.text")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenu1.setMnemonic('E');
        jMenu1.setText(resourceMap.getString("jMenu1.text")); // NOI18N
        jMenu1.setName("jMenu1"); // NOI18N

        jMenuItem1.setAction(actionMap.get("showOptionBox")); // NOI18N
        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText(resourceMap.getString("jMenuItem1.text")); // NOI18N
        jMenuItem1.setName("jMenuItem1"); // NOI18N
        jMenu1.add(jMenuItem1);

        menuBar.add(jMenu1);

        helpMenu.setMnemonic('H');
        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.CTRL_MASK));
        aboutMenuItem.setText(resourceMap.getString("aboutMenuItem.text")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 800, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 616, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void SearchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SearchButtonActionPerformed
        //SearchEdit.getText();
        String target = SearchEdit.getText();
        if (target.equals("")) {
            putLog("全アイテムを取得、表示します");
        } else {
            putLog(target + "の検索を開始しました");
        }
}//GEN-LAST:event_SearchButtonActionPerformed

    private void SearchTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SearchTableMouseClicked
        int col = SearchTable.columnAtPoint(evt.getPoint());
        if (col == 0 && evt.getClickCount() == 2) {          
            putLog("ダブルクリック!");
            SearchTable.repaint();
        } else {
            // 1回クリック時のイベント
        }
    }//GEN-LAST:event_SearchTableMouseClicked

    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel DownloadPanel;
    private javax.swing.table.DefaultTableModel DownloadTableModel;
    private javax.swing.JTable DownloadTable;
    private javax.swing.JPanel LogPanel;
    private javax.swing.JTextArea LogText;
    private javax.swing.JButton SearchButton;
    private javax.swing.JTextField SearchEdit;
    private javax.swing.JPanel SearchPanel;
    private javax.swing.table.DefaultTableModel SearchTableModel;
    private javax.swing.JTable SearchTable;
    private javax.swing.JPanel SendPanel;
    private javax.swing.JPanel UploadPanel;
    private javax.swing.table.DefaultTableModel UploadTableModel;
    private javax.swing.JTable UploadTable;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPanel4;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
    private JDialog optionBox;
}
